library NppDirector;
{$R *.res}

uses
	Windows, Sysutils;

Const
	ndm_getscintillamain = wm_user+101;
	ndm_getscintillasecond = wm_user+102;
	ndm_getnppwindow  = wm_user+103;
	NAME = 'NppDirector';
	CLASSNAME = NAME+'Window';
	
Type
	NppData = Record
		nppHandle : HWnd;
		scintillaMainHandle : HWnd;
		scintillaSecondHandle : HWnd;
	end;
	PNppData = ^NppData;
	FuncItem = Record 
		_itemName: Array[1..64] of WCHAR;
		func: pointer;
		_cmdID: integer;
		_init2Check: integer;
		_pShKey: pointer;
	end;
	PFuncItem = ^FuncItem;

var
	hSciMain, hSciSecond, hNpp: HWnd;
	func: FuncItem;

function WindowProc(Window: HWnd; AMessage, WParam,
										LParam: Longint): Longint; stdcall; export;
begin
	case AMessage of
		ndm_getscintillamain: 
		begin
			WindowProc := hSciMain;
		end;
		ndm_getscintillasecond: 
		begin 
			WindowProc := hSciSecond;
		end;
		ndm_getnppwindow: 
		begin
			WindowProc := hNpp;
		end;
	else
		WindowProc := DefWindowProc(Window, AMessage, WParam, LParam);
	end;
end;

procedure setInfo(data : PNppData); cdecl; export;
begin
	hSciMain := data^.scintillaMainHandle;
	hSciSecond := data^.scintillaSecondHandle;
	hNpp := data^.nppHandle;
end;

function getName(): PWideChar; cdecl; export;
begin
	getName := NAME;
end;


procedure About(); cdecl; export;
begin
	MessageBox(0, 'Written by ProgAndy in FreePascal', 'About NppDirector', 0);
end;

function getFuncsArray(count : Pinteger): PFuncItem; cdecl; export;
begin
	count^ := 1;
	func._itemName := 'About';
	func._cmdID := 1234;
	func._init2Check := 0;
	func._pShKey := nil;
	func.func := @About;
	getFuncsArray := @func;
end;

procedure beNotified(notify: PInteger); cdecl; export;
begin
	notify^ := 0;
end;

function messageProc(msg: integer; wParam, lParam: Longint): Longint; cdecl; export;
begin
	messageProc := 0;
end;

function isUnicode(): integer; cdecl; export;
begin
	isUnicode := 1;
end;

exports
	setInfo, getName, beNotified, messageProc, getFuncsArray, isUnicode;

	 { Register the Window Class }
function WinRegister: Boolean;
var
  WindowClass: WndClass;
begin
  WindowClass.Style := cs_hRedraw or cs_vRedraw;
  WindowClass.lpfnWndProc := WndProc(@WindowProc);
  WindowClass.cbClsExtra := 0;
  WindowClass.cbWndExtra := 0;
  WindowClass.hInstance := system.MainInstance;
  WindowClass.hIcon := 0;
  WindowClass.hCursor := 0;
  WindowClass.hbrBackground := GetStockObject(WHITE_BRUSH);
  WindowClass.lpszMenuName := nil;
  WindowClass.lpszClassName := CLASSNAME;

  WinRegister := RegisterClass(WindowClass) <> 0;
end;

 { Create the Window Class }
function WinCreate: HWnd;
begin
  WinCreate := CreateWindow(CLASSNAME, CLASSNAME,
              ws_OverlappedWindow, cw_UseDefault, cw_UseDefault,
              cw_UseDefault, cw_UseDefault, 0, 0, system.MainInstance, nil);
end;

begin
	WinRegister();
	WinCreate();
end.
